#if v2_52_0
using Adaptation._Tests.Shared;
using Adaptation.Shared;
using Adaptation.Shared.Methods;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Text.Json;

namespace Adaptation._Tests.Extract.Staging.v2_52_0;

[TestClass]
public class METCLIMATEC
{

#pragma warning disable CA2254
#pragma warning disable IDE0060

    private static CreateSelfDescription.Staging.v2_52_0.METCLIMATEC _METCLIMATEC;

    [ClassInitialize]
    public static void ClassInitialize(TestContext testContext)
    {
        CreateSelfDescription.Staging.v2_52_0.METCLIMATEC.ClassInitialize(testContext);
        _METCLIMATEC = CreateSelfDescription.Staging.v2_52_0.METCLIMATEC.EAFLoggingUnitTesting;
    }

    private static void NonThrowTryCatch()
    {
        try
        { throw new Exception(); }
        catch (Exception) { }
    }

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__csv638465291633220311__Normal()
    {
        bool validatePDSF = false;
        string check = "*.csv.trg";
        _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__csv();
        MethodBase methodBase = new StackFrame().GetMethod();
        // string check = "Dev *, A*, present-value, *D*-*-*-*.csv.trg";
        Assert.IsFalse(string.IsNullOrEmpty(_METCLIMATEC.AdaptationTesting.TestContext.FullyQualifiedTestClassName));
        string[] variables = _METCLIMATEC.AdaptationTesting.GetVariables(methodBase, check, validatePDSF);
        IFileRead fileRead = _METCLIMATEC.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsNotNull(extractResult.Item3);
        Assert.IsNotNull(extractResult.Item4);
        NonThrowTryCatch();
    }

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__MoveMatchingFiles() => _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__MoveMatchingFiles();

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__MoveMatchingFiles637953064190000000__Normal()
    {
        string check = "*.pdsf";
        bool validatePDSF = false;
        MethodBase methodBase = new StackFrame().GetMethod();
        _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__MoveMatchingFiles();
        Assert.IsFalse(string.IsNullOrEmpty(_METCLIMATEC.AdaptationTesting.TestContext.FullyQualifiedTestClassName));
        string[] variables = _METCLIMATEC.AdaptationTesting.GetVariables(methodBase, check, validatePDSF);
        IFileRead fileRead = _METCLIMATEC.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Logistics logistics = new(fileRead);
        _ = AdaptationTesting.ReExtractCompareUpdatePassDirectory(variables, fileRead, logistics, validatePDSF);
    }

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__IQSSi() => _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__IQSSi();

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__IQSSi638465291633220310__Normal()
    {
        string check = "*.pdsf";
        _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__IQSSi();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _METCLIMATEC.AdaptationTesting.GetVariables(methodBase, check, validatePDSF: false);
        IFileRead fileRead = _METCLIMATEC.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Logistics logistics = new(fileRead);
        _ = AdaptationTesting.ReExtractCompareUpdatePassDirectory(variables, fileRead, logistics);
        NonThrowTryCatch();
    }

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__Processed() => _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__Processed();

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__Archive() => _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__Archive();

#if DEBUG
    [Ignore]
#endif
    [TestMethod]
    public void Staging__v2_52_0__METCLIMATEC__Dummy() => _METCLIMATEC.Staging__v2_52_0__METCLIMATEC__Dummy();

}
#endif